# sec-search-client
API for receiving classifications of SEC filings.  Note that this API is in  beta and is subject to change before the release of a stable v1.0.0.  By default, the api will return a maximum of 100 results.   To return more results, pass the `page` parameter.   For example, to return the second page of results, pass `page=2`.  <a href=\"https://www.secsearch.io/profile\" target=\"_blank\">Get an API Key</a> 

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 0.1.2
- Package version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.python.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:

```python
import sec_search_client 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:

```python
import sec_search_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import sec_search_client
from sec_search_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: APIKey
configuration = sec_search_client.Configuration()
configuration.api_key['X-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = sec_search_client.CategoryApi(sec_search_client.ApiClient(configuration))

try:
    # All Categories
    api_response = api_instance.all_categories_category_all_get()
    pprint(api_response)
except ApiException as e:
    print("Exception when calling CategoryApi->all_categories_category_all_get: %s\n" % e)

# Configure API key authorization: APIKey
configuration = sec_search_client.Configuration()
configuration.api_key['X-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = sec_search_client.CategoryApi(sec_search_client.ApiClient(configuration))

try:
    # Get Category By Id
    api_response = api_instance.get_category_by_id_category_by_id_category_id_get()
    pprint(api_response)
except ApiException as e:
    print("Exception when calling CategoryApi->get_category_by_id_category_by_id_category_id_get: %s\n" % e)

# Configure API key authorization: APIKey
configuration = sec_search_client.Configuration()
configuration.api_key['X-API-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-API-Key'] = 'Bearer'

# create an instance of the API class
api_instance = sec_search_client.CategoryApi(sec_search_client.ApiClient(configuration))

try:
    # Latest Categories
    api_response = api_instance.latest_categories_category_latest_get()
    pprint(api_response)
except ApiException as e:
    print("Exception when calling CategoryApi->latest_categories_category_latest_get: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to */v1*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*CategoryApi* | [**all_categories_category_all_get**](docs/CategoryApi.md#all_categories_category_all_get) | **GET** /category/all | All Categories
*CategoryApi* | [**get_category_by_id_category_by_id_category_id_get**](docs/CategoryApi.md#get_category_by_id_category_by_id_category_id_get) | **GET** /category/by-id/{category_id} | Get Category By Id
*CategoryApi* | [**latest_categories_category_latest_get**](docs/CategoryApi.md#latest_categories_category_latest_get) | **GET** /category/latest | Latest Categories
*ClassificationApi* | [**all_classifications_classification_all_get**](docs/ClassificationApi.md#all_classifications_classification_all_get) | **GET** /classification/all | All Classifications
*ClassificationApi* | [**classification_search_classification_search_get**](docs/ClassificationApi.md#classification_search_classification_search_get) | **GET** /classification/search | Classification Search
*ClassificationApi* | [**get_classification_by_id_classification_by_name_classification_machine_name_get**](docs/ClassificationApi.md#get_classification_by_id_classification_by_name_classification_machine_name_get) | **GET** /classification/by-name/{classification_machine_name} | Get Classification By Id
*ClassificationApi* | [**latest_classifications_classification_latest_get**](docs/ClassificationApi.md#latest_classifications_classification_latest_get) | **GET** /classification/latest | Latest Classifications
*EntityApi* | [**company_names_entitycompanies_all_get**](docs/EntityApi.md#company_names_entitycompanies_all_get) | **GET** /entitycompanies/all | Company Names
*EntityApi* | [**get_filings_by_cik_entity_cik_cik_get**](docs/EntityApi.md#get_filings_by_cik_entity_cik_cik_get) | **GET** /entity/cik/{cik} | Get Filings By Cik
*EntityApi* | [**search_entities_entity_search_get**](docs/EntityApi.md#search_entities_entity_search_get) | **GET** /entity/search/ | Search Entities
*FilingApi* | [**get_filing_text_filing_path_sequence_text_get**](docs/FilingApi.md#get_filing_text_filing_path_sequence_text_get) | **GET** /filing/{path}/{sequence}/text | Get Filing Text
*FilingApi* | [**get_filings_by_symbol_filing_symbol_symbol_get**](docs/FilingApi.md#get_filings_by_symbol_filing_symbol_symbol_get) | **GET** /filing/symbol/{symbol} | Get Filings By Symbol
*SymbolApi* | [**all_symbols_symbol_all_get**](docs/SymbolApi.md#all_symbols_symbol_all_get) | **GET** /symbol/all | All Symbols
*SymbolApi* | [**search_symbols_symbol_search_get**](docs/SymbolApi.md#search_symbols_symbol_search_get) | **GET** /symbol/search | Search Symbols

## Documentation For Models

 - [HTTPValidationError](docs/HTTPValidationError.md)
 - [ValidationError](docs/ValidationError.md)

## Documentation For Authorization


## APIKey

- **Type**: API key
- **API key parameter name**: X-API-Key
- **Location**: HTTP header


## Author


