# coding: utf-8

"""
    SEC Search API

    API for receiving classifications of SEC filings.  Note that this API is in  beta and is subject to change before the release of a stable v1.0.0.  By default, the api will return a maximum of 100 results.   To return more results, pass the `page` parameter.   For example, to return the second page of results, pass `page=2`.  <a href=\"https://www.secsearch.io/profile\" target=\"_blank\">Get an API Key</a>   # noqa: E501

    OpenAPI spec version: 0.1.2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from sec_search_client.api_client import ApiClient


class ClassificationApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def all_classifications_classification_all_get(self, **kwargs):  # noqa: E501
        """All Classifications  # noqa: E501

        Returns all classifications :return:  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.all_classifications_classification_all_get(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: object
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.all_classifications_classification_all_get_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.all_classifications_classification_all_get_with_http_info(**kwargs)  # noqa: E501
            return data

    def all_classifications_classification_all_get_with_http_info(self, **kwargs):  # noqa: E501
        """All Classifications  # noqa: E501

        Returns all classifications :return:  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.all_classifications_classification_all_get_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: object
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method all_classifications_classification_all_get" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['APIKey']  # noqa: E501

        return self.api_client.call_api(
            '/classification/all', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='object',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def classification_search_classification_search_get(self, **kwargs):  # noqa: E501
        """Classification Search  # noqa: E501

        Returns latest classifications subject to the following constraints: - free account: top 10 - paid account: all results over the last n days paginated by n items per page (max of 100 items per page) :return:  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.classification_search_classification_search_get(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param object classification_machine_name:
        :param object start_date:
        :param object end_date:
        :param object confidence:
        :param object symbol:
        :param object cik:
        :param object form_type:
        :param object page:
        :param object per_page:
        :return: object
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.classification_search_classification_search_get_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.classification_search_classification_search_get_with_http_info(**kwargs)  # noqa: E501
            return data

    def classification_search_classification_search_get_with_http_info(self, **kwargs):  # noqa: E501
        """Classification Search  # noqa: E501

        Returns latest classifications subject to the following constraints: - free account: top 10 - paid account: all results over the last n days paginated by n items per page (max of 100 items per page) :return:  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.classification_search_classification_search_get_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param object classification_machine_name:
        :param object start_date:
        :param object end_date:
        :param object confidence:
        :param object symbol:
        :param object cik:
        :param object form_type:
        :param object page:
        :param object per_page:
        :return: object
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['classification_machine_name', 'start_date', 'end_date', 'confidence', 'symbol', 'cik', 'form_type', 'page', 'per_page']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method classification_search_classification_search_get" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'classification_machine_name' in params:
            query_params.append(('classification_machine_name', params['classification_machine_name']))  # noqa: E501
        if 'start_date' in params:
            query_params.append(('start_date', params['start_date']))  # noqa: E501
        if 'end_date' in params:
            query_params.append(('end_date', params['end_date']))  # noqa: E501
        if 'confidence' in params:
            query_params.append(('confidence', params['confidence']))  # noqa: E501
        if 'symbol' in params:
            query_params.append(('symbol', params['symbol']))  # noqa: E501
        if 'cik' in params:
            query_params.append(('cik', params['cik']))  # noqa: E501
        if 'form_type' in params:
            query_params.append(('form_type', params['form_type']))  # noqa: E501
        if 'page' in params:
            query_params.append(('page', params['page']))  # noqa: E501
        if 'per_page' in params:
            query_params.append(('per_page', params['per_page']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['APIKey']  # noqa: E501

        return self.api_client.call_api(
            '/classification/search', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='object',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_classification_by_id_classification_by_name_classification_machine_name_get(self, classification_machine_name, **kwargs):  # noqa: E501
        """Get Classification By Id  # noqa: E501

        Returns latest classifications subject to the following constraints: - free account: top 10 - paid account: all results over the last n days paginated by n items per page :return:  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_classification_by_id_classification_by_name_classification_machine_name_get(classification_machine_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param object classification_machine_name: (required)
        :param object days:
        :param object page:
        :param object per_page:
        :return: object
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_classification_by_id_classification_by_name_classification_machine_name_get_with_http_info(classification_machine_name, **kwargs)  # noqa: E501
        else:
            (data) = self.get_classification_by_id_classification_by_name_classification_machine_name_get_with_http_info(classification_machine_name, **kwargs)  # noqa: E501
            return data

    def get_classification_by_id_classification_by_name_classification_machine_name_get_with_http_info(self, classification_machine_name, **kwargs):  # noqa: E501
        """Get Classification By Id  # noqa: E501

        Returns latest classifications subject to the following constraints: - free account: top 10 - paid account: all results over the last n days paginated by n items per page :return:  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_classification_by_id_classification_by_name_classification_machine_name_get_with_http_info(classification_machine_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param object classification_machine_name: (required)
        :param object days:
        :param object page:
        :param object per_page:
        :return: object
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['classification_machine_name', 'days', 'page', 'per_page']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_classification_by_id_classification_by_name_classification_machine_name_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'classification_machine_name' is set
        if ('classification_machine_name' not in params or
                params['classification_machine_name'] is None):
            raise ValueError("Missing the required parameter `classification_machine_name` when calling `get_classification_by_id_classification_by_name_classification_machine_name_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'classification_machine_name' in params:
            path_params['classification_machine_name'] = params['classification_machine_name']  # noqa: E501

        query_params = []
        if 'days' in params:
            query_params.append(('days', params['days']))  # noqa: E501
        if 'page' in params:
            query_params.append(('page', params['page']))  # noqa: E501
        if 'per_page' in params:
            query_params.append(('per_page', params['per_page']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['APIKey']  # noqa: E501

        return self.api_client.call_api(
            '/classification/by-name/{classification_machine_name}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='object',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def latest_classifications_classification_latest_get(self, **kwargs):  # noqa: E501
        """Latest Classifications  # noqa: E501

        Returns latest classifications subject to the following constraints: - free account: top 10 - paid account: all results over the last 30 days paginated by n items per page :return:  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.latest_classifications_classification_latest_get(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: object
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.latest_classifications_classification_latest_get_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.latest_classifications_classification_latest_get_with_http_info(**kwargs)  # noqa: E501
            return data

    def latest_classifications_classification_latest_get_with_http_info(self, **kwargs):  # noqa: E501
        """Latest Classifications  # noqa: E501

        Returns latest classifications subject to the following constraints: - free account: top 10 - paid account: all results over the last 30 days paginated by n items per page :return:  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.latest_classifications_classification_latest_get_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: object
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method latest_classifications_classification_latest_get" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['APIKey']  # noqa: E501

        return self.api_client.call_api(
            '/classification/latest', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='object',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
